/***********************************************************************
 *
 * Copyright (C) 2009 Graeme Gott <graeme@gottcode.org>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 ***********************************************************************/

#ifndef BOARD_H
#define BOARD_H

#include <QWidget>
class QLabel;
class Cell;
class Puzzle;

class Board : public QWidget {
	Q_OBJECT
public:
	Board(QWidget* parent = 0);

	void newPuzzle(int seed = 0, bool load = false);

	bool notesMode() const {
		return m_notes_mode;
	}

	bool isFinished() const {
		return m_finished;
	}

	void checkFinished();

	void moveFocus(int column, int row, int deltax, int deltay);

	Cell* cell(int column, int row) const {
		column = qBound(0, column, 9);
		row = qBound(0, row, 9);
		return m_cells[column][row];
	}

public slots:
	void showWrong(bool show = true);
	void setMode(int mode);

private:
	Cell* m_cells[9][9];
	Puzzle* m_puzzle;
	bool m_notes_mode;
	bool m_finished;
	QLabel* m_message;
};

#endif
